function InitializeBuffListener()

  buff_list.EffectAdded = function(sender, args)
    if setContains(bonus_buffs, buff_list:Get(args.Index):GetName()) then
      UpdateBonus()
    elseif setContains(outpost_buffs, buff_list:Get(args.Index):GetName()) then
      UpdateOutposts()
      end
  end

  buff_list.EffectRemoved = function(sender, args)
    if setContains(bonus_buffs, args.Effect:GetName()) then
      UpdateBonus()
    elseif setContains(outpost_buffs, args.Effect:GetName()) then
      UpdateOutposts()
    end
  end
  
  UpdateOutposts()
  UpdateBonus()
end

function UpdateBonus()
  local bonus = 0
  
  for i = 1, buff_list:GetCount() do
    local element = buff_list:Get(i):GetName()
    if setContains(bonus_buffs, element) then
      bonus = bonus + bonus_buffs[element]
    end
  end

  if bonus % 10 == 6 then
    bonus = bonus - 3
  end
  
  overviewWindow.label_bonus:SetText(L.BuffWatcher_Bonus..bonus.."%")
  mapWindow:UpdateKeepsOnMap()
end

function UpdateOutposts()
  local bonus = 0

  for i = 1, buff_list:GetCount() do
    local element = buff_list:Get(i):GetName()
    if setContains(outpost_buffs, element) then
      bonus = bonus + 1
    end
  end

  overviewWindow.outpost1:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))
  overviewWindow.outpost2:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))
  overviewWindow.outpost3:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))
  overviewWindow.outpost4:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))

  if bonus >= 1 then overviewWindow.outpost1:SetBackColor(AlignmentColor) end
  if bonus >= 2 then overviewWindow.outpost2:SetBackColor(AlignmentColor) end
  if bonus >= 3 then overviewWindow.outpost3:SetBackColor(AlignmentColor) end
  if bonus == 4 then overviewWindow.outpost4:SetBackColor(AlignmentColor) end

  mapWindow:UpdateKeepsOnMap()
end

function setContains(set, key)
    return set[key]
end
