
LoadData = function()

	SetGlobals()

	if storage == nil then
  	_G.storage = { ["numbers"] = {} }
  else
		data_loaded = true
		-- convert saved strings back into numbers
		data.numbers = ConvertStringsToNumbers(storage.numbers)
	end
	
	SetDefaults()
	
	data.numbers.overview_width_ratio = data.numbers.overview_width_ratio / 100000000000000

end

SetGlobals = function()

  if (Turbine.Gameplay.LocalPlayer.GetInstance():GetAlignment() == Turbine.Gameplay.Alignment.MonsterPlayer) then
    _G.Rank_Icons = {
      [0]=nil, [1]=0x410080b7, [2]=0x410080b8, [3]=0x410080b9, [4]=0x410080ba, [5]=0x410080bb,
      [6]=0x410080bc, [7]=0x410080bd, [8]=0x410080be, [9]=0x410080b0, [10]=0x410080b1,
      [11]=0x410080b2, [12]=0x410080b3, [13]=0x410080b4, [14]=0x410080b5, [15]=0x410080b6
    }
    _G.AlignmentColor = Turbine.UI.Color(213/255,26/255,58/255)
    _G.OwnKeepIcon = 0x4100819c
    _G.OpponentKeepIcon = 0x4100819b
  else
    _G.Rank_Icons = {
      [0]=nil, [1]=0x410080a8, [2]=0x410080a9, [3]=0x410080aa, [4]=0x410080ab, [5]=0x410080ac,
      [6]=0x410080ad, [7]=0x410080ae, [8]=0x410080af, [9]=0x410080a1, [10]=0x410080a2,
      [11]=0x410080a3, [12]=0x410080a4, [13]=0x410080a5, [14]=0x410080a6, [15]=0x410080a7
    }
    _G.AlignmentColor = Turbine.UI.Color(53/255,119/255,234/255)
    _G.OwnKeepIcon = 0x4100819b
    _G.OpponentKeepIcon = 0x4100819c
  end
	_G.Ranks = {
    [0]=0, [1]=500, [2]=1250, [3]=2750, [4]=5750, [5]=14750,
    [6]=33500, [7]=71000,[8]=146000, [9]=258500, [10]=408500, [11]=633500,
    [12]=1008500, [13]=1608500, [14]=2508500, [15]=3708500
  }
  _G.buff_list = nil
	_G.minimal_width = 360
	_G.new_fight1 = false
	_G.new_fight2 = false
	_G.data_loaded = false
	_G.points_last_fight = 0
	_G.comms_last_fight = 0
	_G.current_commendations = 0
  _G.alertCounter = 0
  _G.currentPositionCounter = 0
  _G.enemyPosVisible = 60
  _G.default_font_color = Turbine.UI.Color(245/255,222/255,147/255)
  _G.posChatColor = "#FF4500"
  _G.positionPattern = "%[.+] (.+): '?<rgb="..posChatColor..">(%d*) ?.+ @ .+: .+: (%d+%.%d)S, (%d+%.%d)W</rgb>'?"
  _G.usedUserChannels = { [1] = nil, [2] = nil, [3] = nil, [4] = nil }
	_G.storage = Turbine.PluginData.Load(Turbine.DataScope.Character,"PvMP_Plus")
	_G.last_commendations = tonumber(Turbine.PluginData.Load(Turbine.DataScope.Server,"PvMP_Plus"))
	_G.data = { ["numbers"] = {} }
end

SetDefaults = function()

  if storage.last5kills == nil then storage.last5kills = {} end
  if data.numbers.frags == nil then data.numbers.frags = {}	end
	if data.numbers.recent_points == nil then data.numbers.recent_points = {} end
  if data.numbers.recent_tracks == nil then data.numbers.recent_tracks = {} end
	if data.numbers.recent_frags == nil then data.numbers.recent_frags = {} end
	if data.numbers.recent_comms == nil then data.numbers.recent_comms = {} end
  if data.numbers.history == nil then data.numbers.history = {} end
  if data.numbers.history.points == nil then data.numbers.history.points = {} end
  if data.numbers.history.frags == nil then data.numbers.history.frags = {} end
	if data.numbers.current_day == nil then data.numbers.current_day = Turbine.Engine.GetDate().DayOfYear end
	if data.numbers.points_current_day == nil then data.numbers.points_current_day = 0 end
	if data.numbers.frags_current_day == nil then data.numbers.frags_current_day = 0 end
	if data.numbers.tracks_current_day == nil then data.numbers.tracks_current_day = 0 end
	if data.numbers.comms_current_day == nil then data.numbers.comms_current_day = 0 end
  if data.numbers.most_points_a_day == nil then data.numbers.most_points_a_day = { 0, 1, 1, 1970 } end
  if data.numbers.most_frags_a_day == nil then data.numbers.most_frags_a_day = { 0, 1, 1, 1970 } end
  if data.numbers.tracks_total == nil then data.numbers.tracks_total = 0 end
	if data.numbers.points_total == nil then data.numbers.points_total = 0 end
  if data.numbers.resettime == nil then data.numbers.resettime = 0 end
	if data.numbers.overview_width_ratio == nil then data.numbers.overview_width_ratio = 30000000000000 end
	local fixed_ratio = data.numbers.overview_width_ratio / 100000000000000
	local display_width = Turbine.UI.Display.GetWidth()
 	local display_height = Turbine.UI.Display.GetHeight() 
	if data.numbers.overview_x == nil then data.numbers.overview_x = math.floor(display_width / 2 - (minimal_width + (display_width - minimal_width) * fixed_ratio) / 2) end
	if data.numbers.overview_y == nil then data.numbers.overview_y = 0 end
  if data.numbers.alert_x == nil then data.numbers.alert_x = math.floor(display_width / 2 - 200) end
  if data.numbers.alert_y == nil then data.numbers.alert_y = math.floor(display_height / 4) end
	if data.numbers.secondaryWin_x == nil then data.numbers.secondaryWin_x = display_width - 140 end
	if data.numbers.secondaryWin_y == nil then data.numbers.secondaryWin_y = display_height / 2 - 125 end

end

Plugins["PvMP+"].Unload = function(self, args, isDailyBackup)

	data.numbers.overview_width_ratio = data.numbers.overview_width_ratio * 100000000000000

	-- only save points last 24 hours
	data.numbers.recent_points = DeleteObsoleteData(data.numbers.recent_points)
	data.numbers.recent_tracks = DeleteObsoleteData(data.numbers.recent_tracks)
  data.numbers.recent_frags = DeleteObsoleteData(data.numbers.recent_frags)
  data.numbers.recent_comms = DeleteObsoleteData(data.numbers.recent_comms)
  
  -- only save history data last 20 days
  data.numbers.history.points = DeleteOldHistoryData(data.numbers.history.points, 20)
  data.numbers.history.frags = DeleteOldHistoryData(data.numbers.history.frags, 20)
  
	-- convert data into strings
	storage.numbers = ConvertNumbersToStrings(data.numbers)

  if isDailyBackup then
    Turbine.PluginData.Save(Turbine.DataScope.Character, "PvMP_Plus_Daily_Backup", storage)
  else
    Turbine.PluginData.Save(Turbine.DataScope.Server, "PvMP_Plus", tostring(current_commendations))
    Turbine.PluginData.Save(Turbine.DataScope.Character, "PvMP_Plus", storage)
    Turbine.PluginData.Save(Turbine.DataScope.Character, "PvMP_Plus_Backup", storage)
  end

	data.numbers.overview_width_ratio = data.numbers.overview_width_ratio / 100000000000000
end

function ConvertStringsToNumbers(data)
	local temp = {}
	
	for i,j in pairs(data) do
		if type(j) == "table" then
			temp[i] = ConvertStringsToNumbers(j)
		elseif type(j) == "string" then
			local test = tonumber(i)
			if test == nil then
				temp[i] = tonumber(j)
			else
				temp[tonumber(i)] = tonumber(j)
			end
		end
	end

	return temp
end

function ConvertNumbersToStrings(input)
	local temp = {}
	
	for i,j in pairs(input) do
		if type(j) == "table" then
			temp[i] = ConvertNumbersToStrings(j)
		elseif type(j) == "number" then
			temp[tostring(i)] = tostring(j)
		end
	end

	return temp
end

function DeleteObsoleteData(input)
	local important_data = {}
	local now = GetSecondsOfYear()
	
	for timestamp,value in pairs(input) do
		if (now - timestamp <= 86400 and now - timestamp >= 0) then
			important_data[timestamp] = value		
		end
	end
  
	return important_data
end

function GetRemainingPoints()
	for i=0, 14 do
		if (data.numbers.points_total >= Ranks[i] and data.numbers.points_total < Ranks[i+1]) then
			return Ranks[i+1] - data.numbers.points_total
		end
	end
  return 0
end

function GetDaysPerYear(year)
  local daysPerYear = 365
  if year == 2012 or year == 2016 or year == 2020 then daysPerYear = 366 end
  return daysPerYear
end

function GetDaysPerMonth(month, year)
  if month==4  or month==6 or month==9 or month==11 then
    return 30
  elseif month == 2 then
    if GetDaysPerYear(year)==365 then return 28
    else return 29 end
  else
    return 31
  end
end

function DeleteOldHistoryData(data, days)
	local important_data = {}
  local current_date = Turbine.Engine.GetDate()
  local current_day = current_date.DayOfYear 
  
  for i=0, days - 1 do
    local day = current_day - i
    if day < 1 then day = GetDaysPerYear(current_date.Year - 1) + day end
    if not (data[day] == nil) then
      important_data[day] = data[day]
    end
  end
  
	return important_data
end