DragBar = class(Turbine.UI.Control)

function DragBar:Constructor(prnt, text)

  local parent = prnt
  local width = parent:GetWidth()
  local height = parent:GetHeight()
  
  Turbine.UI.Control.Constructor(self)
  
  self:SetParent(parent)

  self:SetSize(width,height)
  self:SetWantsKeyEvents(true)
  self:SetMouseVisible(false)
  self:SetZOrder(1)

  self.MovePanel = Turbine.UI.Control()
  self.MovePanel:SetParent(self)
  self.MovePanel:SetSize(2000,20)
  self.MovePanel:SetBackground("PvMP_Plus/Resources/DragBar/dragbar.tga")

  self.MoveText = Turbine.UI.Label()
  self.MoveText:SetParent(self.MovePanel)
  self.MoveText:SetSize(width,12)
  self.MoveText:SetTop(4)
  self.MoveText:SetFont(Turbine.UI.Lotro.Font.Verdana12)
  self.MoveText:SetText(text)
	self.MoveText:SetFontStyle(Turbine.UI.FontStyle.Outline)
  self.MoveText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.MoveText:SetMouseVisible(false)

	-- REPOSITIONING --
  -- shadow box
  self.shadowBox = Turbine.UI.Control()
  self.shadowBox:SetParent(self)
  self.shadowBox:SetTop(20)
	self.shadowBox:SetSize(width, height)
  self.shadowBox:SetMouseVisible(false)
  self.shadowBox:SetVisible(false)

  -- top left corner
  self.shadowBox.topLeft = Turbine.UI.Control()
  self.shadowBox.topLeft:SetParent(self.shadowBox)
  self.shadowBox.topLeft:SetSize(10, 10)
  self.shadowBox.topLeft:SetMouseVisible(false)
  self.shadowBox.topLeft:SetBackground("PvMP_Plus/Resources/DragBar/drag_topleft.tga")
  self.shadowBox.topLeft:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)

  -- topRight
  self.shadowBox.topRight = Turbine.UI.Control()
  self.shadowBox.topRight:SetParent(self.shadowBox)
  self.shadowBox.topRight:SetSize(10, 10)
  self.shadowBox.topRight:SetMouseVisible(false)
  self.shadowBox.topRight:SetBackground("PvMP_Plus/Resources/DragBar/drag_topright.tga")
  self.shadowBox.topRight:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)

  -- bottomLeft
  self.shadowBox.bottomLeft = Turbine.UI.Control()
  self.shadowBox.bottomLeft:SetParent(self.shadowBox)
  self.shadowBox.bottomLeft:SetSize(10, 10)
  self.shadowBox.bottomLeft:SetMouseVisible(false)
  self.shadowBox.bottomLeft:SetBackground("PvMP_Plus/Resources/DragBar/drag_bottomleft.tga")
  self.shadowBox.bottomLeft:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)

  -- bottomRight
  self.shadowBox.bottomRight = Turbine.UI.Control()
  self.shadowBox.bottomRight:SetParent(self.shadowBox)
  self.shadowBox.bottomRight:SetSize(10, 10)
  self.shadowBox.bottomRight:SetMouseVisible(false)
  self.shadowBox.bottomRight:SetBackground("PvMP_Plus/Resources/DragBar/drag_bottomright.tga")
  self.shadowBox.bottomRight:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)

	-- top side
  self.shadowBox.top = Turbine.UI.Control()
  self.shadowBox.top:SetParent(self.shadowBox)
  self.shadowBox.top:SetSize(0, 10)
  self.shadowBox.top:SetMouseVisible(false)
  self.shadowBox.top:SetBackground("PvMP_Plus/Resources/DragBar/drag_topmid.tga")
  self.shadowBox.top:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)

  -- left side
  self.shadowBox.left = Turbine.UI.Control()
  self.shadowBox.left:SetParent(self.shadowBox)
  self.shadowBox.left:SetSize(10, 0)
  self.shadowBox.left:SetMouseVisible(false)
  self.shadowBox.left:SetBackground("PvMP_Plus/Resources/DragBar/drag_midleft.tga")
  self.shadowBox.left:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)

  -- right side
  self.shadowBox.right = Turbine.UI.Control()
  self.shadowBox.right:SetParent(self.shadowBox)
  self.shadowBox.right:SetSize(10, 0)
  self.shadowBox.right:SetMouseVisible(false)
  self.shadowBox.right:SetBackground("PvMP_Plus/Resources/DragBar/drag_midright.tga")
  self.shadowBox.right:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)

  -- bottom side
  self.shadowBox.bottom = Turbine.UI.Control()
  self.shadowBox.bottom:SetParent(self.shadowBox)
  self.shadowBox.bottom:SetSize(0, 10)
  self.shadowBox.bottom:SetMouseVisible(false)
  self.shadowBox.bottom:SetBackground("PvMP_Plus/Resources/DragBar/drag_bottommid.tga")
  self.shadowBox.bottom:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)

  self.shadowBox.SizeChanged = function(sender, args)
    local width, height = sender:GetSize()
    self.shadowBox.top:SetPosition(10, 0)
    self.shadowBox.topRight:SetPosition(width - 10, 0)
    self.shadowBox.bottomLeft:SetPosition(0, height - 30)
    self.shadowBox.bottom:SetPosition(10, height - 30)
    self.shadowBox.bottomRight:SetPosition(width - 10, height - 30)
    self.shadowBox.left:SetPosition(0, 10)
    self.shadowBox.right:SetPosition(width - 10, 10)
    self.shadowBox.top:SetWidth(width - 20)
    self.shadowBox.bottom:SetWidth(width - 20)
    self.shadowBox.left:SetHeight(height - 40)
    self.shadowBox.right:SetHeight(height - 40)
  end

  self:SetVisible(false)
 
  self.Moving = false

  self.MovePanel.MouseDown = function(sender,args)
    self.MoveX = args.X
    self.MoveY = args.Y
    self.Moving = true
    self.MovePanel:SetBackground("PvMP_Plus/Resources/DragBar/dragbar_clicked.tga")
  end
    
  self.MovePanel.MouseUp = function()
    self.Moving = false
    self.MovePanel:SetBackground("PvMP_Plus/Resources/DragBar/dragbar.tga")
  end
    
  self.MovePanel.MouseMove = function(sender,args)
    if self.Moving then
      local newLeft = parent:GetLeft() - (self.MoveX - args.X)
      local newTop = parent:GetTop() - (self.MoveY - args.Y)
      if newLeft < 0 then newLeft = 0 end
      if newTop < 0 then newTop = 0 end
      if newLeft > (Turbine.UI.Display.GetWidth() - parent:GetWidth()) then
        newLeft = Turbine.UI.Display.GetWidth() - parent:GetWidth() end
      if newTop > (Turbine.UI.Display.GetHeight() - parent:GetHeight()) then
        newTop = Turbine.UI.Display.GetHeight() - parent:GetHeight() end
      parent:SetPosition(newLeft,newTop)
    end
  end

	self.MovePanel.MouseEnter = function()
		self.shadowBox:SetVisible(true)
	end
		
	self.MovePanel.MouseLeave = function()
		self.shadowBox:SetVisible(false)
	end
  
  self.KeyDown = function(sender,args) 
    if args.Action == Turbine.UI.Lotro.Action.RepositionUI then
      self:SetVisible(not self:IsVisible())
    end
  end
  
  parent.SizeChanged = function(sender, args)
    self:SetSize(sender:GetSize())
    self.shadowBox:SetSize(sender:GetSize())
    self.MoveText:SetWidth(sender:GetWidth())
  end

  self.shadowBox:SizeChanged()

end