Tab = class(Turbine.UI.Button)
function Tab:Constructor(parent, tabIndex, pos, background, mouseover, selected, selected_mouseover)

  Turbine.UI.Button.Constructor(self)

  self.isSelected = false
  self.index = tabIndex
  self.normal = background
  self.mouseover = mouseover
  self.selected = selected
  self.mouseover_selected = selected_mouseover

  self:SetParent(parent)
  self:SetSize((parent:GetWidth() - 20)/3, 60)
  self:SetPosition(20 + pos * (parent:GetWidth() - 50)/3, 20)
  self:SetBackground(self.normal)
  self:SetWantsKeyEvents(true)
  self:SetBlendMode(Turbine.UI.BlendMode.Overlay)
  
  self.Click = function()
    parent.tab_stats:SetBackground(parent.tab_stats.normal)
    parent.tab_stats.isSelected = false
    parent.tab_killList:SetBackground(parent.tab_killList.normal)
    parent.tab_killList.isSelected = false
    parent.tab_barChart:SetBackground(parent.tab_barChart.normal)    
    parent.tab_barChart.isSelected = false

    self:SetBackground(self.mouseover_selected)
    self.isSelected = true
    parent:ShowTab(self.index)
  end
  
  self.MouseEnter = function()
    if self.isSelected then
      self:SetBackground(self.mouseover_selected)
    else
      self:SetBackground(self.mouseover)
    end
  end
  self.MouseLeave = function()
    if self.isSelected then
      self:SetBackground(self.selected)
    else
      self:SetBackground(self.normal)
    end
  end
end

OverviewLabel = class(Turbine.UI.Label)
function OverviewLabel:Constructor(parent, width, pos, color)

  Turbine.UI.Label.Constructor(self)
  
  self:SetParent(parent)
  self:SetSize(width/4,20)
  self:SetForeColor(color)
	self:SetPosition(pos * width/4,0)
	self:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
	self:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self:SetMouseVisible(false)
  
end

StatsLabel = class(Turbine.UI.Label)
function StatsLabel:Constructor(parent, pos)

  Turbine.UI.Label.Constructor(self)

  self:SetParent(parent)
  self:SetSize(parent:GetWidth(),15)
  self:SetPosition(0,pos)
  self:SetFont(Turbine.UI.Lotro.Font.Verdana12)
  self:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)

end