OverviewWindow = class(Turbine.UI.Window)
 
function OverviewWindow:Constructor()

  Turbine.UI.Window.Constructor(self)
  local width = math.ceil(minimal_width + (Turbine.UI.Display.GetWidth() - minimal_width) * data.numbers.overview_width_ratio)
  local height = 90
	self:SetSize(width,height)

	self:SetPosition(data.numbers.overview_x,data.numbers.overview_y)
  self:SetWantsKeyEvents(true)
  self:SetMouseVisible(false)
  
  self.DragBar = DragBar(self, "PvMP+")

  self.panel = Turbine.UI.Label()
	self.panel:SetParent(self)
	self.panel:SetSize(width,height)
  self.panel:SetMouseVisible(false)
  
	self.bar_start = 50
	self.bar_end = self:GetWidth() - self.bar_start
	self.bar_length = self.bar_end - self.bar_start
	--
	self.empty_bar = Turbine.UI.Label()
	self.empty_bar:SetParent(self.panel)
	self.empty_bar:SetSize(self.bar_length,14)
	self.empty_bar:SetPosition(self.bar_start,27)
	self.empty_bar:SetBackground("PvMP_Plus/Resources/ProgressBar/bar_empty.tga")
	self.empty_bar:SetMouseVisible(false)

	self.filled_bar = Turbine.UI.Label()
	self.filled_bar:SetParent(self.panel)
	self.filled_bar:SetSize(0,14)
	self.filled_bar:SetPosition(self.bar_start,27)
	self.filled_bar:SetBackground("PvMP_Plus/Resources/ProgressBar/bar_filled.tga")
	self.filled_bar:SetMouseVisible(false)

	self.left_end = Turbine.UI.Label()
	self.left_end:SetParent(self.panel)
	self.left_end:SetSize(6,18)
	self.left_end:SetPosition(self.bar_start-3,25)
	self.left_end:SetBackground("PvMP_Plus/Resources/ProgressBar/bar_left.tga")
	self.left_end:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
	self.left_end:SetMouseVisible(false)

	self.right_end = Turbine.UI.Label()
	self.right_end:SetParent(self.panel)
	self.right_end:SetSize(6,18)
	self.right_end:SetPosition(self.bar_end-3,25)
	self.right_end:SetBackground("PvMP_Plus/Resources/ProgressBar/bar_right.tga")	
	self.right_end:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
	self.right_end:SetMouseVisible(false)
	
	self.middle = Turbine.UI.Label()
	self.middle:SetParent(self.panel)
	self.middle:SetSize(self.bar_length-6,18)
	self.middle:SetPosition(self.bar_start+3,25)
	self.middle:SetBackground("PvMP_Plus/Resources/ProgressBar/bar_middle.tga")	
	self.middle:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
	self.middle:SetMouseVisible(false)
	
	self.percentage = Turbine.UI.Label()
	self.percentage:SetParent(self.panel)
  self.percentage:SetSize(width,18)
  self.percentage:SetPosition(0,25)
  self.percentage:SetFont(Turbine.UI.Lotro.Font.Verdana12)
  self.percentage:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.percentage:SetMouseVisible(false)
	
  ------------------------------------------------------------
  self.bonus_panel = Turbine.UI.Label()
  self.bonus_panel:SetParent(self.panel)
  self.bonus_panel:SetSize(95,25) -- label direkt zwischen rank- und commendations-label
	self.bonus_panel:SetPosition(width/2-self.bonus_panel:GetSize()/2,0)
  self.bonus_panel:SetMouseVisible(false)
  self.bonus_panel:SetVisible(not storage.show_bonus_disabled)

  self.label_bonus = Turbine.UI.Label()
  self.label_bonus:SetParent(self.bonus_panel)
  self.label_bonus:SetSize(self.bonus_panel:GetSize())
	self.label_bonus:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.label_bonus:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	self.label_bonus:SetFontStyle(Turbine.UI.FontStyle.Outline)
  self.label_bonus:SetMouseVisible(false)

  self.outpost1 = Turbine.UI.Label()
  self.outpost1:SetParent(self.bonus_panel)
  self.outpost1:SetSize(20,3)
	self.outpost1:SetPosition(0,19)
  self.outpost1:SetMouseVisible(false)

  self.outpost2 = Turbine.UI.Label()
  self.outpost2:SetParent(self.bonus_panel)
  self.outpost2:SetSize(20,3)
	self.outpost2:SetPosition(25,19)
  self.outpost2:SetMouseVisible(false)
  
  self.outpost3 = Turbine.UI.Label()
  self.outpost3:SetParent(self.bonus_panel)
  self.outpost3:SetSize(20,3)
	self.outpost3:SetPosition(50,19)
  self.outpost3:SetMouseVisible(false)

  self.outpost4 = Turbine.UI.Label()
  self.outpost4:SetParent(self.bonus_panel)
  self.outpost4:SetSize(20,3)
	self.outpost4:SetPosition(75,19)
  self.outpost4:SetMouseVisible(false)
  ------------------------------------------------------------
  self.label_points = Turbine.UI.Label()
  self.label_points:SetParent(self.panel)
  self.label_points:SetSize(width - 108,20) -- label direkt zwischen rank- und commendations-label
  self.label_points:SetForeColor(default_font_color)
	self.label_points:SetPosition(width/2-self.label_points:GetSize()/2,45)
	self.label_points:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.label_points:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
	self.label_points:SetFontStyle(Turbine.UI.FontStyle.Outline)
	------------------------------------------------------------
  self.points_panel = Turbine.UI.Label()
  self.points_panel:SetParent(self.panel)
  self.points_panel:SetSize(width,20)
	self.points_panel:SetPosition(0,70)
	self.points_panel:SetMouseVisible(false)
  self.label_day = OverviewLabel(self.points_panel,width,0,default_font_color)
  self.label_last_hour = OverviewLabel(self.points_panel,width,1,default_font_color)
  self.label_10min = OverviewLabel(self.points_panel,width,2,default_font_color)
  self.label_last_fight = OverviewLabel(self.points_panel,width,3,default_font_color)
	------------------------------------------------------------
  self.comms_panel = Turbine.UI.Label()
  self.comms_panel:SetParent(self.panel)
  self.comms_panel:SetSize(width,20)
	self.comms_panel:SetPosition(0,70)
	self.comms_panel:SetMouseVisible(false)
  self.comms_panel:SetVisible(false)
  self.label_day_comms = OverviewLabel(self.comms_panel,width,0, Turbine.UI.Color(0/255,253/255,255/255))
  self.label_last_hour_comms = OverviewLabel(self.comms_panel,width,1, Turbine.UI.Color(0/255,253/255,255/255))
  self.label_10min_comms = OverviewLabel(self.comms_panel,width,2, Turbine.UI.Color(0/255,253/255,255/255))
  self.label_last_fight_comms = OverviewLabel(self.comms_panel,width,3, Turbine.UI.Color(0/255,253/255,255/255))
	------------------------------------------------------------
  self.commendations_panel = Turbine.UI.Label()
  self.commendations_panel:SetParent(self.panel)
  self.commendations_panel:SetSize(54,50)
	self.commendations_panel:SetPosition(width-54,18)
  self.commendations_panel.MouseEnter = function()
    if not storage.stats_hidden then
      self.points_panel:SetVisible(false)
      self.comms_panel:SetVisible(true)
    end
  end
  self.commendations_panel.MouseLeave = function()
    if not storage.stats_hidden then
      self.points_panel:SetVisible(true)
      self.comms_panel:SetVisible(false)
    end
  end
  ------------------------------------------------------------
  self.label_commendations = Turbine.UI.Label()
  self.label_commendations:SetParent(self.commendations_panel)
  self.label_commendations:SetSize(54,20)
  self.label_commendations:SetForeColor(default_font_color)
	self.label_commendations:SetPosition(0,30)
	self.label_commendations:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.label_commendations:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
	self.label_commendations:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self.label_commendations:SetMouseVisible(false)
  ------------------------------------------------------------
  self.pic_commendations = Turbine.UI.Control()
  self.pic_commendations:SetParent(self.commendations_panel)
  self.pic_commendations:SetSize(32,32)
	self.pic_commendations:SetPosition(11,0)
	self.pic_commendations:SetBackground(0x41123495)
	self.pic_commendations:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
	self.pic_commendations:SetMouseVisible(false)
  ------------------------------------------------------------
	self.label_rank = Turbine.UI.Label()
  self.label_rank:SetParent(self.panel)
  self.label_rank:SetSize(54,20)
  self.label_rank:SetForeColor(default_font_color)
	self.label_rank:SetPosition(0,48)
	self.label_rank:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.label_rank:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
	self.label_rank:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self.label_rank:SetMouseVisible(false)
  ------------------------------------------------------------
  self.pic_rank = Turbine.UI.Control()
  self.pic_rank:SetParent(self.panel)
  self.pic_rank:SetSize(32,32)
	self.pic_rank:SetPosition(11,18)
	self.pic_rank:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
	self.pic_rank:SetMouseVisible(false)
  ------------------------------------------------------------
	self.separator = Turbine.UI.Control()
  self.separator:SetParent(self.panel)
  self.separator:SetSize(width,1)
	self.separator:SetPosition(0,70)
	self.separator:SetBackColor(default_font_color)
	self.separator:SetMouseVisible(false)
	------------------------------------------------------------
	self:SetStatsVisibility(not storage.stats_hidden)
	------------------------------------------------------------

  self.PositionChanged = function(sender, args)
		data.numbers.overview_x = self:GetLeft()
		data.numbers.overview_y = self:GetTop()
    overview_settings_panel:SetPosition(self:GetLeft() + self:GetWidth() - overview_settings_panel:GetWidth(), self:GetTop())	
  end
  
	self.label_points.MouseDown = function()
		storage.show_remaining_points = not storage.show_remaining_points
		self:Update()
	end
	
  self.KeyDown = function(sender,args) 
    if args.Action == Turbine.UI.Lotro.Action.ToggleHUD then
			self:SetVisible(not self:IsVisible()) -- toggle visibility of Overview-Window
			overview_settings_panel:SetVisible(not overview_settings_panel:IsVisible()) -- toggle visibility of Overview-Control
      secondaryWindow:SetVisible(not (secondaryWindow:IsVisible() or storage.secondaryMinimized or storage.minimized))      
      alertWindow:SetVisible(not alertWindow:IsVisible())
    end
  end
	
end

function OverviewWindow:Update()

  commsLast24h, commsLastHour, commsLast10Min = GetRecentData(data.numbers.recent_comms)
  pointsLast24h, pointsLastHour, pointsLast10Min = GetRecentData(data.numbers.recent_points)

  self.label_commendations:SetText(FormatPoints(current_commendations))

	if self:GetWidth() < 600 then
		if storage.show_remaining_points then
			self.label_points:SetText(L.Stats_Remaining_Points_Short .. FormatPoints(GetRemainingPoints()))
		else
			self.label_points:SetText(L.Stats_Total_Points_Short .. FormatPoints(data.numbers.points_total))
		end
		self.label_day:SetText(L.Stats_Current_Day_Short .. FormatPoints(data.numbers.points_current_day))
		self.label_last_hour:SetText(L.Stats_Last_Hour_Short.. pointsLastHour)
		self.label_10min:SetText(L.Stats_Last_10min_Short .. pointsLast10Min)
		self.label_last_fight:SetText(L.Stats_Last_Fight_Short .. FormatPoints(points_last_fight))
		self.label_day_comms:SetText(L.Stats_Current_Day_Short .. FormatPoints(data.numbers.comms_current_day))
		self.label_last_hour_comms:SetText(L.Stats_Last_Hour_Short.. commsLastHour)
		self.label_10min_comms:SetText(L.Stats_Last_10min_Short .. commsLast10Min)
		self.label_last_fight_comms:SetText(L.Stats_Last_Fight_Short .. comms_last_fight)
	else
		if storage.show_remaining_points then
			self.label_points:SetText(L.Stats_Remaining_Points .. FormatPoints(GetRemainingPoints()))
		else
			self.label_points:SetText(L.Stats_Total_Points .. FormatPoints(data.numbers.points_total))
		end
		self.label_day:SetText(L.Stats_Current_Day .. FormatPoints(data.numbers.points_current_day))
		self.label_last_hour:SetText(L.Stats_Last_Hour.. pointsLastHour)
		self.label_10min:SetText(L.Stats_Last_10min .. pointsLast10Min)
		self.label_last_fight:SetText(L.Stats_Last_Fight .. FormatPoints(points_last_fight))
		self.label_day_comms:SetText(L.Stats_Current_Day .. FormatPoints(data.numbers.comms_current_day))
		self.label_last_hour_comms:SetText(L.Stats_Last_Hour.. commsLastHour)
		self.label_10min_comms:SetText(L.Stats_Last_10min .. commsLast10Min)
		self.label_last_fight_comms:SetText(L.Stats_Last_Fight .. FormatPoints(comms_last_fight))

	end
	
	overview_settings_panel:UpdateChatData()
	
	for i=0, 14 do
		if (data.numbers.points_total >= Ranks[i] and data.numbers.points_total < Ranks[i+1]) then
			local rank_difference = Ranks[i+1] - Ranks[i]
			local points_since_rankup = data.numbers.points_total - Ranks[i]
			local percentage_done = points_since_rankup / rank_difference
			self.pic_rank:SetBackground(Rank_Icons[i])
			self.label_rank:SetText(L.Strings_Rank..i)
			self:UpdateProgressBar(percentage_done)
			return
		end
	end
	self.pic_rank:SetBackground(Rank_Icons[15])
	self.label_rank:SetText(L.Strings_Rank.."15")
	self:UpdateProgressBar(1) -- Rank 15
end

function OverviewWindow:UpdateProgressBar(percentage_done)
	self.percentage:SetText(math.floor(percentage_done*10000)/100 .. "%")
	local filled_pixel = math.floor(self.bar_length * percentage_done)	
	self.filled_bar:SetWidth(filled_pixel)
end

function OverviewWindow:UpdatePosition()
	local old_width = self:GetWidth()
	local new_width = math.floor(minimal_width + (Turbine.UI.Display.GetWidth() - minimal_width) * data.numbers.overview_width_ratio)
	if new_width / 2 ~= math.floor((new_width + 1) / 2) then new_width = new_width + 1 end -- true wenn new_width NICHT ohne rest durch 2 teilbar ist
	data.numbers.overview_x = data.numbers.overview_x - (new_width - old_width) / 2
	if data.numbers.overview_x < 0 then data.numbers.overview_x = 0 end
	if data.numbers.overview_x + new_width > Turbine.UI.Display.GetWidth() then data.numbers.overview_x = Turbine.UI.Display.GetWidth() - new_width end
	self:SetWidth(new_width)
	self:SetPosition(data.numbers.overview_x,data.numbers.overview_y)
	self:UpdateBarLength()
  self.panel:SetWidth(new_width)
  self.separator:SetWidth(new_width)
	self.commendations_panel:SetPosition(self:GetWidth()-54,18)
  self.points_panel:SetWidth(new_width)
  self.comms_panel:SetWidth(new_width)
  self.label_points:SetSize(new_width - 108,20) -- label direkt zwischen rank- und commendations-label
  self.label_day:SetSize(new_width/4,20)
  self.label_last_hour:SetSize(new_width/4,20)
	self.label_last_hour:SetPosition(new_width/4,0)
  self.label_10min:SetSize(new_width/4,20)
	self.label_10min:SetPosition(2 * new_width/4,0)
  self.label_last_fight:SetSize(new_width/4,20)
	self.label_last_fight:SetPosition(3 * new_width/4,0)
  self.label_day_comms:SetSize(new_width/4,20)
  self.label_last_hour_comms:SetSize(new_width/4,20)
  self.label_last_hour_comms:SetPosition(new_width/4,0)
  self.label_10min_comms:SetSize(new_width/4,20)
  self.label_10min_comms:SetPosition(2 * new_width/4,0)
  self.label_last_fight_comms:SetSize(new_width/4,20)
  self.label_last_fight_comms:SetPosition(3 * new_width/4,0)
	self.bonus_panel:SetPosition(new_width/2-self.bonus_panel:GetSize()/2,0)
	overview_settings_panel:SetPosition(self:GetLeft() + new_width - overview_settings_panel:GetWidth(), self:GetTop())
  self:Update()
end

function OverviewWindow:UpdateBarLength()
	self.bar_start = 50
	self.bar_end = self:GetWidth() - self.bar_start
	self.bar_length = self.bar_end - self.bar_start
	self.empty_bar:SetWidth(self.bar_length)
	self.middle:SetWidth(self.bar_length-6)
	self.right_end:SetPosition(self.bar_end-3,25)
	self.percentage:SetWidth(self:GetWidth())
end

function OverviewWindow:ToggleStatsVisibility()
	storage.stats_hidden = self.separator:IsVisible()
	self:SetStatsVisibility(not storage.stats_hidden)	
end
		
function OverviewWindow:SetStatsVisibility(flag)
	self.separator:SetVisible(flag)
	self.points_panel:SetVisible(flag)
end