Settings = class(Turbine.UI.Window)
 
function Settings:Constructor()

  local width = 215
  local height = 380
  local x = Turbine.UI.Display:GetWidth()/2 - width/2
  local y = Turbine.UI.Display:GetHeight()/2 - height/2

  Turbine.UI.Lotro.Window.Constructor(self)
  
  self:SetSize(width,height)
  self:SetPosition(x,y)
  self:SetZOrder(1)
  self:SetText("PvMP+")
  self:SetWantsKeyEvents(true)
	------------------------------------------------------------
	self.update_button = Turbine.UI.Lotro.Button()
	self.update_button:SetText(L.Options_Update)
	self.update_button:SetWidth(width - 40)
	self.update_button:SetPosition(width/2 - self.update_button:GetWidth()/2,50)
	self.update_button:SetParent(self)

	self.reset_button = Turbine.UI.Lotro.Button()
	self.reset_button:SetText(L.Options_Reset)
	self.reset_button:SetWidth(width - 40)
	self.reset_button:SetPosition(width/2 - self.reset_button:GetWidth()/2,80)
	self.reset_button:SetParent(self)
	
	self.show_stats_checkbox = Turbine.UI.Lotro.CheckBox()
	self.show_stats_checkbox:SetParent(self)
	self.show_stats_checkbox:SetText(" "..L.Options_Show_Stats)
	self.show_stats_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.show_stats_checkbox:SetForeColor(default_font_color)
  self.show_stats_checkbox:SetSize(width - 40,16)
	self.show_stats_checkbox:SetPosition(width/2 - self.show_stats_checkbox:GetWidth()/2,self.reset_button:GetTop() + 31)
	self.show_stats_checkbox:SetChecked(not storage.stats_hidden)

	self.comms_warning_checkbox = Turbine.UI.Lotro.CheckBox()
	self.comms_warning_checkbox:SetParent(self)
	self.comms_warning_checkbox:SetText(" "..L.Options_Commendation_Warning)
	self.comms_warning_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.comms_warning_checkbox:SetForeColor(default_font_color)
  self.comms_warning_checkbox:SetSize(width - 40,16)
	self.comms_warning_checkbox:SetPosition(width/2 - self.comms_warning_checkbox:GetWidth()/2, self.show_stats_checkbox:GetTop() + 26)
	self.comms_warning_checkbox:SetChecked(not storage.comms_warning_disabled)
  
	self.track_warning_checkbox = Turbine.UI.Lotro.CheckBox()
	self.track_warning_checkbox:SetParent(self)
	self.track_warning_checkbox:SetText(" "..L.Options_Track_Warning)
	self.track_warning_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.track_warning_checkbox:SetForeColor(default_font_color)
  self.track_warning_checkbox:SetSize(width - 40,16)
	self.track_warning_checkbox:SetPosition(width/2 - self.track_warning_checkbox:GetWidth()/2,self.comms_warning_checkbox:GetTop() + 26)
	self.track_warning_checkbox:SetChecked(not storage.track_warning_disabled)
	
  self.lootbox_alert_checkbox = Turbine.UI.Lotro.CheckBox()
	self.lootbox_alert_checkbox:SetParent(self)
	self.lootbox_alert_checkbox:SetText(" "..L.Options_LootboxAlert)
	self.lootbox_alert_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.lootbox_alert_checkbox:SetForeColor(default_font_color)
  self.lootbox_alert_checkbox:SetSize(width - 40,16)
	self.lootbox_alert_checkbox:SetPosition(width/2 - self.lootbox_alert_checkbox:GetWidth()/2,self.track_warning_checkbox:GetTop() + 26)
	self.lootbox_alert_checkbox:SetChecked(not storage.lootbox_alert_disabled)

  self.bonus_checkbox = Turbine.UI.Lotro.CheckBox()
	self.bonus_checkbox:SetParent(self)
	self.bonus_checkbox:SetText(" "..L.Options_Bonus)
  self.bonus_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.bonus_checkbox:SetForeColor(default_font_color)
  self.bonus_checkbox:SetSize(width - 40,16)
	self.bonus_checkbox:SetPosition(width/2 - self.bonus_checkbox:GetWidth()/2,self.lootbox_alert_checkbox:GetTop() + 26)
	self.bonus_checkbox:SetChecked(not storage.show_bonus_disabled)
  
  self.recent_kills_checkbox = Turbine.UI.Lotro.CheckBox()
	self.recent_kills_checkbox:SetParent(self)
	self.recent_kills_checkbox:SetText(" "..L.ShowRecentKills)
  self.recent_kills_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.recent_kills_checkbox:SetForeColor(default_font_color)
  self.recent_kills_checkbox:SetSize(width - 40,16)
	self.recent_kills_checkbox:SetPosition(width/2 - self.bonus_checkbox:GetWidth()/2,self.bonus_checkbox:GetTop() + 26)
	self.recent_kills_checkbox:SetChecked(not storage.show_recent_kills_disabled)
  
  self.reset_time = Turbine.UI.Label()
  self.reset_time:SetText(L.Daily_Reset_Time)
	self.reset_time:SetParent(self)
	self.reset_time:SetSize(width - 40,16)
	self.reset_time:SetPosition(width/2 - self.reset_time:GetWidth()/2, self.recent_kills_checkbox:GetTop() + 26)
	self.reset_time:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.reset_time:SetForeColor(default_font_color)
	self.reset_time:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)

  self.reset_time_time = Turbine.UI.Label()
	self.reset_time_time:SetParent(self)
	self.reset_time_time:SetSize(35,20)
	self.reset_time_time:SetPosition(width - 28 - self.reset_time_time:GetWidth(), self.recent_kills_checkbox:GetTop() + 24)
	self.reset_time_time:SetForeColor(default_font_color)
	self.reset_time_time:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
	self.reset_time_time:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.reset_time_time:SetText(data.numbers.resettime..":00")

  self.reset_time_plus = Turbine.UI.Button()
  self.reset_time_plus:SetParent(self)
	self.reset_time_plus:SetSize(10,10)
	self.reset_time_plus:SetPosition(self.reset_time_time:GetLeft() + self.reset_time_time:GetWidth(), self.reset_time_time:GetTop())
	self.reset_time_plus:SetForeColor(default_font_color)
  self.reset_time_plus:SetFont(Turbine.UI.Lotro.Font.Verdana10)
	self.reset_time_plus:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.reset_time_plus:SetText("+")
  self.reset_time_plus.MouseDown = function()
    local time_value = tonumber(string.match(self.reset_time_time:GetText(), '(%d+):00'))
    local new_value = time_value + 1
    if new_value == 24 then new_value = 0 end
    data.numbers.resettime = new_value
    self.reset_time_time:SetText(new_value..":00")
  end
  self.reset_time_minus = Turbine.UI.Button()
  self.reset_time_minus:SetParent(self)
	self.reset_time_minus:SetSize(10,10)
	self.reset_time_minus:SetPosition(self.reset_time_time:GetLeft() + self.reset_time_time:GetWidth(), self.reset_time_time:GetTop() + 10)
	self.reset_time_minus:SetForeColor(default_font_color)
  self.reset_time_minus:SetFont(Turbine.UI.Lotro.Font.Verdana10)
	self.reset_time_minus:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.reset_time_minus:SetText("-")
  self.reset_time_minus.MouseDown = function()
    local time_value = tonumber(string.match(self.reset_time_time:GetText(), '(%d+):00'))
    local new_value = time_value - 1
    if new_value == -1 then new_value = 23 end
    data.numbers.resettime = new_value
    self.reset_time_time:SetText(new_value..":00")
  end

	self.slider_label = Turbine.UI.Label()
	self.slider_label:SetText(L.Options_Window_Size)
	self.slider_label:SetParent(self)
	self.slider_label:SetSize(width,30)
	self.slider_label:SetPosition(width/2 - self.slider_label:GetWidth()/2 + 20,self.reset_time:GetTop() + 15)
	self.slider_label:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.slider_label:SetForeColor(default_font_color)
	self.slider_label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)

	self.slider_bar = Turbine.UI.Label()
	self.slider_bar:SetParent(self)
	self.slider_bar:SetSize(width - 40,15)
	self.slider_bar:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
	self.slider_bar:SetBackground("PvMP_Plus/Resources/slider_bar.tga")
	self.slider_bar:SetPosition(20,self.slider_label:GetTop() + 27)

	self.slider_bar.MouseDown = function(sender,args)
    local newLeft = args.X + 20 - self.slider:GetWidth()/2
    if newLeft < 20 then newLeft = 20 end
    if newLeft > 179 then newLeft = 179 end
    self.slider:SetPosition(newLeft, self.slider:GetTop())
		data.numbers.overview_width_ratio = (newLeft - 20) / (self.slider_bar:GetWidth() - self.slider:GetWidth())
    overviewWindow:UpdatePosition()
  end

	self.slider = Turbine.UI.Control()
	self.slider:SetParent(self)
	self.slider:SetSize(16,16)
	self.slider:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
	self.slider:SetBackground(0x41007e0c)
	self.slider:SetPosition(20 + data.numbers.overview_width_ratio * (self.slider_bar:GetWidth() - self.slider:GetWidth()),self.slider_label:GetTop() + 27)

	self.slider.MouseDown = function(sender,args)
    self.MoveX = args.X
    self.MoveY = args.Y
    self.sliding = true
  end

  self.slider.MouseUp = function(sender,args)
    self.sliding = false
  end

  self.slider.MouseMove = function(sender,args)
    if self.sliding then
      local newLeft = self.slider:GetLeft() - (self.MoveX - args.X)
      if newLeft < 20 then newLeft = 20 end
      if newLeft > 179 then newLeft = 179 end
			self.slider:SetPosition(newLeft, self.slider:GetTop())
			data.numbers.overview_width_ratio = (newLeft - 20) / (self.slider_bar:GetWidth() - self.slider:GetWidth())
      overviewWindow:UpdatePosition()
    end
  end

	self.ok_button = Turbine.UI.Lotro.Button()
	self.ok_button:SetText(L.OK)
	self.ok_button:SetPosition(width/2 - self.ok_button:GetWidth()/2,self.slider:GetTop() + 28)
	self.ok_button:SetParent(self)

	self.comms_warning_checkbox.CheckedChanged = function()
		storage.comms_warning_disabled = not storage.comms_warning_disabled
	end

	self.show_stats_checkbox.CheckedChanged = function()
		overviewWindow:ToggleStatsVisibility()
	end

	self.track_warning_checkbox.CheckedChanged = function()
		storage.track_warning_disabled = not storage.track_warning_disabled
	end

	self.lootbox_alert_checkbox.CheckedChanged = function()
		storage.lootbox_alert_disabled = not storage.lootbox_alert_disabled
	end
  
  self.bonus_checkbox.CheckedChanged = function()
		storage.show_bonus_disabled = not storage.show_bonus_disabled
    overviewWindow.bonus_panel:SetVisible(not storage.show_bonus_disabled)
	end

  self.recent_kills_checkbox.CheckedChanged = function()
    storage.show_recent_kills_disabled = not storage.show_recent_kills_disabled
    secondaryWindow:ShowRecentKills(not storage.show_recent_kills_disabled)
	end

	self.update_button.Click = function()
		initWindow:Open()
	end

  self.reset_button.Click = function()
    local display_width = Turbine.UI.Display.GetWidth()
    local display_height = Turbine.UI.Display.GetHeight() 
		data.numbers.overview_y = 0
		data.numbers.overview_width_ratio = 0.3
    data.numbers.alert_x = math.floor(display_width / 2 - 200)
    data.numbers.alert_y = math.floor(display_height / 4)
    data.numbers.secondaryWin_x = display_width - secondaryWindow:GetWidth()
    data.numbers.secondaryWin_y = display_height / 2 - 125
    alertWindow:SetPosition(data.numbers.alert_x,data.numbers.alert_y)
    secondaryWindow:SetPosition(data.numbers.secondaryWin_x,data.numbers.secondaryWin_y)
		data.numbers.overview_x = math.floor(display_width/2 - overviewWindow:GetWidth()/2)
		self.slider:SetPosition(20 + data.numbers.overview_width_ratio * (self.slider_bar:GetWidth() - self.slider:GetWidth()),self.slider:GetTop())
		overview_settings_panel.plusminus:SetBackground("PvMP_Plus/Resources/minus.tga")
		overviewWindow.panel:SetVisible(true)
    storage.minimized = false
    storage.secondaryMinimized = false
		storage.show_remaining_points = false
    secondaryWindow:SetVisible(true)
		overviewWindow:SetVisible(true)
		self.show_stats_checkbox:SetChecked(true)
		self.comms_warning_checkbox:SetChecked(true)
    self.track_warning_checkbox:SetChecked(true)
    self.lootbox_alert_checkbox:SetChecked(true)
    self.recent_kills_checkbox:SetChecked(true)
    self.bonus_checkbox:SetChecked(true)
    data.numbers.resettime = 0
    self.reset_time_time:SetText(data.numbers.resettime..":00")
		overviewWindow:UpdatePosition()
	end
	
	self.ok_button.Click = function()
		self:SetVisible(false)
	end
	
  self.KeyDown = function(sender,args) 
    if args.Action == Turbine.UI.Lotro.Action.Escape then
      self:SetVisible(false)
    end
  end
  
end

function Settings:Open()
	self:SetVisible(true)
end